import PropTypes from 'prop-types';
import { HTMLProps, KeyboardEventHandler, MouseEventHandler } from 'react';
import type { Size } from '../types';
import { noop } from '../utils';
interface ClearButtonProps extends Omit<HTMLProps<HTMLButtonElement>, 'size'> {
    label?: string;
    onClick: MouseEventHandler<HTMLButtonElement>;
    onKeyDown: KeyboardEventHandler<HTMLButtonElement>;
    size?: Size;
}
declare const ClearButton: {
    ({ className, label, onClick, onKeyDown, size, ...props }: ClearButtonProps): JSX.Element;
    propTypes: {
        label: PropTypes.Requireable<string>;
        onClick: PropTypes.Requireable<(...args: any[]) => any>;
        onKeyDown: PropTypes.Requireable<(...args: any[]) => any>;
        size: PropTypes.Requireable<"large" | "lg" | "small" | "sm">;
    };
    defaultProps: {
        label: string;
        onClick: typeof noop;
        onKeyDown: typeof noop;
    };
};
export default ClearButton;
